# Simple Banking API

> Leveraging Java 8, create an application that simulates simple banking transactions.

## Requirements:

* Build the application using Java 8.
* All interaction with the user should be done through the console using the Scanner class.
* Customers of the bank should be able to register with a username and password, and apply to open an account.
* Customers should be able to apply for joint accounts.
* Once the account is open, customers should be able to withdraw, deposit, and transfer funds between accounts.
* All basic validation should be done, such as trying to input negative amounts, overdrawing from accounts etc.
* Employees of the bank should be able to view all of their customers' information. This includes:
   * Account information
   * Account balances
   * Personal information
* Employees should be able to approve/deny open applications for accounts.
* Bank admins should be able to view and edit all accounts.
This includes:
   * Approving/denying accounts
   * Withdrawing, depositing, transferring from all accounts
   * Canceling accounts
* All information should be persisted using a SQL database.
* You should use the DAO design pattern with JDBC for data connectivity.
* You must write at least 25 JUnit tests to ensure application quality.
* Logging should be accomplished using Log4J.
* All transactions should be logged.

## Required Technologies:

* Java 8
* Maven
* JUnit
* Mockito
* Log4J
* PostgreSQL
* JDBC

